%if 0%{?fedora} || 0%{?rhel} == 6
# Not all devel deps exist in Fedora so you can't
# install the devel rpm so we need to build without
# devel or unit_test for now
%global with_devel 0
%global with_bundled 1
%global with_debug 1
%global with_check 1
%global with_unit_test 0
%else
%global with_devel 0
%global with_bundled 1
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

# https://fedoraproject.org/wiki/PackagingDrafts/Go#Debuginfo
# https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

# https://fedoraproject.org/wiki/PackagingDrafts/Go#Debuginfo
%if ! 0%{?gobuild:1}
%define gobuild(o:) go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};
%endif

%global provider        github
%global provider_tld    com
%global project         kushaldas
%global repo            gotun
# https://github.com/kushaldas/gotun
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          e6546c3f9ddf21ff558840dca1bb2d196d18d1ee
%global shortcommit     %(c=%{commit}; echo ${c:0:7})


Name:           gotun
Version:        0.1.0
Release:        0.1.git%{shortcommit}%{?dist}
Summary:        Tool to run tests on OpenStack
License:        GPLv3
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

%description
Tool to run tests on OpenStack or remote system.


# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

# Main package BuildRequires
%if ! 0%{?with_bundled}
# cli/main/main.go
BuildRequires: golang(github.com/urfave/cli)
# Remaining dependencies not included in main packages
BuildRequires: golang(github.com/rackspace/gophercloud)
BuildRequires: golang(github.com/spf13/viper)
BuildRequires: golang(github.com/urfave/cli)
BuildRequires: golang(golang.org/x/crypto/ssh)
%endif



Requires: golang(github.com/rackspace/gophercloud)
Requires: golang(github.com/spf13/viper)
Requires: golang(golang.org/x/crypto/ssh)
BuildRequires: golang(github.com/urfave/cli)

%prep
%setup -q -n %{repo}-%{commit}

%build
# set up temporary build gopath in pwd
mkdir -p src/%{provider}.%{provider_tld}/%{project}
ln -s ../../../ src/%{import_path}
export GOPATH=$(pwd):%{gopath}


%gobuild -o bin/gotun %{import_path}

%install
install -d -p %{buildroot}%{_bindir}
install -p -m 0755 bin/gotun %{buildroot}%{_bindir}


%files
%license LICENSE
%doc README.md 
%{_bindir}/gotun


%changelog
* Thu Sep 22 2016 Kushal Das <kushal@fedoraproject.org> - 0.1.0-0.1.gite6546c3
- First package for Fedora
